'SizeAllFramesToObject.csc
'Copyright 2003-2005 by Abe Hendin / AtYourSpeed Consulting. Public domain.
'Contact <venturadev@yourspeed.com> with suggestions or comments.
'March 10, 2005
'Version 1.0

'Starts with the current page, and sizes all frames on the page
'to object. Accounts for frames being pulled up from subsequent pages.
'Does all pages in a chapter; could be easily modified to do all pages 
'in a pub.
'Assumes that all frames will shrink. May break if frames jump to the 
'next page (not tested).

WITHOBJECT "CorelVentura.Automation.10"
	DIM lCurrPage AS LONG, lNextPage AS LONG
	DIM lFramesToDo AS LONG, lNewFrameCount AS LONG, lEndCount AS LONG
	DIM lStartFrameCount AS LONG
	DIM lFrame AS LONG
	
	DO
		lCurrPage = .CurrentPageNumber(, 2) 'relative to pub
		lFramesToDo = .FrameCount()	'get initial frame count
		lNewFrameCount = lFramesToDo	'set initial starting point
		lEndCount = 1	'set initial end count
		DO UNTIL lFramesToDo <= 0
			lStartFrameCount = lNewFrameCount
			'loop through frames starting with last to account for frames
			'being pulled up as they shrink:
			FOR lFrame = lNewFrameCount TO lEndCount STEP - 1
				.FrameFirst FALSE, lFrame
				.FrameSizeToObject	'resize frame to its graphic
			NEXT
			lNewFrameCount = .FrameCount()
			'set lFramesToDo to just those frames pulled up from the next page:
			lFramesToDo = lNewFrameCount - lStartFrameCount
			'set stopping point to prevent redoing frames already done:
			lEndCount = lNewFrameCount - lFramesToDo + 1
		LOOP
		
		.ViewGotoPage , , 0, 3 'goto next page of chapter
REM 		.ViewGotoPage , , 2, 3 'goto next page of pub
		lNextPage = .CurrentPageNumber(, 2) 'relative to pub
	LOOP UNTIL lNextPage = lCurrPage
END WITHOBJECT

